#!/usr/bin/perl
# $Id: BNG2.pl,v 1.7 2007/02/02 16:17:19 faeder Exp $

use FindBin;
use lib $FindBin::Bin;
use BNGModel;
use SpeciesList;
use BNGUtils;
use strict;

# turn off output buffering on STDOUT
(select(*STDOUT), $|=1)[0];

printf "BioNetGen version %s\n", BNGversion();
 
my $model= BNGModel->new();
my %params=();
my $generate_network=0;
while ($ARGV[0] =~ /^-/){
  $_ = shift;
  if (/^-check$/){
    $params{no_exec}=1;
  }
  else{
    exit_error("Unrecognized command line option $_");
  }
}

for my $file(@ARGV){
  #exit_error("File $file does not have required .bngl extension.") unless ( ($file=~ /[.]bngl/));
  $params{file}=$file;
  if (my $err=$model->readFile(\%params)){exit_error($err);}
}

printf "CPU TIME: total %.1f s.\n", cpu_time(0);

