#!/usr/bin/perl

$ordered=0;
$file1= shift(@ARGV);
$file2= shift(@ARGV);

open(file1) || die "Couldn't open ${file1}: $!";
open(file2) || die "Couldn't open ${file2}: $!";

@rxn1=();
READ1:
while(<file1>){
  next unless (/^begin reactions/);
  while(<file1>){
    last READ1 if /^end reactions/;
    ($index, $reac, $prod, $rate)= split(' ');
    $reac= join(',',sort {$a<=>$b} split(',',$reac));
    $prod= join(',',sort {$a<=>$b} split(',',$prod));
    push @rxn1, "$reac $prod $rate";
  }
}

@rxn2=();
READ2:
while(<file2>){
  next unless (/^begin reactions/);
  while(<file2>){
    last READ2 if /^end reactions/;
    ($index, $reac, $prod, $rate)= split(' ');
    $reac= join(',',sort {$a<=>$b} split(',',$reac));
    $prod= join(',',sort {$a<=>$b} split(',',$prod));
    push @rxn2, "$reac $prod $rate";
  }
}

if ($ordered){
  for $i (0..$#rxn1){
    next if ($rxn1[$i] eq $rxn2[$i]);
    printf "Mismatch at reaction %d:\n %s\n %s\n", $i+1, $rxn1[$i], $rxn2[$i];
  }
} else {
  %rxns1=();
  for $rxn (@rxn1){
    $rxns1{$rxn}=1;
  }  
  %rxns2=();
  for $rxn (@rxn2){
    $rxns2{$rxn}=1;
  }  
  for $i (0..$#rxn1){
    if (!defined($rxns2{$rxn1[$i]})){
      printf "No match for rxn %d of $file1: %s\n", $i+1, $rxn1[$i];
    }
    if (!defined($rxns1{$rxn2[$i]})){
      printf "No match for rxn %d of $file2: %s\n", $i+1, $rxn2[$i];
    }
  }
}
